;-----------------------------------------------------------------------------------
; db_lib_api.au3      
;-----------------------------------------------------------------------------------
; InspectDataSource		;   
; AllocateConnection		; 
; FreeResources			;  
; StaticSQLStatement		; / SQL
; QuerySQLStatement		;   
; ReloadStatement		;  
; ExternalRuns			;  
; RecteateDataTables		;    
; RedJet			;  Access
; ODBCErroHandler		; 

;[   ]
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Func InspectDataSource($SourceType)

Local $undef	;       

	;[   ODBC]
	;----------------------------------------------------------------------------
	$dll_1 = DllOpen("odbccp32.dll")
	If $dll_1=-1 then 
		ODBCErroHandler(10)
		return 0
	EndIf

	;[   ]
	;----------------------------------------------------------------------------
	Select 
	Case $SourceType=1	;   ACCESS
		$DSN="DepoAccess"
		$str1="Access"
		$str2="Access files(*.mdb)|All files(*.*)"
		$ext="mdb"
	Case $SourceType=2	;   EXCEL
		$DSN="DepoExcel"
		$str1="Excel"
		$str2="Excel files(*.xls)|All files(*.*)"
		$ext="xls"
	EndSelect

	;[    ]
	;----------------------------------------------------------------------------
	$message = MsgBox(51,$TITLE,"    " & $str1 & "?." 	& @CRLF & _
		" ,     ." 		& @CRLF & _
		"    JET     .")
	Select
		Case $message = 6 ;
			$pathToDb=FileOpenDialog ("  " & $str1, _
							  $WorkDir & "\source", _
	        	 				  $str2)
				If @error then return 0
				If FileExists ($pathToDb)=0 then return 0

			$sspl=StringSplit($pathToDb,"\")
			;------------------------------------------------------------
			$fileName=$sspl[$sspl[0]]
			$defDir=StringReplace ($pathToDb,"\" & $fileName,"")
			$undef=False
	;----------------------------------------------------------------------------
	   	Case $message = 7 ;
			$defDir=FileSelectFolder ("    " & $str1 & ". JET     .", _
					  "")
			If @error then return 0
			$fileName="source." & $ext
			$undef=True
   		Case $message = 2 ;
		return 0
	EndSelect

	;[   ]
	;----------------------------------------------------------------------------
	Select 

		Case $SourceType=1	;   ACCESS

		;[   Acccess]
		;---------------------------------------------------------------------

		$DriverType=		"Microsoft Access Driver (*.mdb)"
		$ConfigurationData=	"DSN=" & $DSN & ";" & _
					"Description=   [Access];" & _
					"DBQ=" & $defDir & "\" & $fileName & ";" & _
					"DefaultDir=" & $defDir & ";" & _
					"Driver={Microsoft Access Driver (*.mdb)};" & _
					"ExtendedAnsiSQL=0;" & _
					"FIL=MS Access;" & _
					"ImplicitCommitSync=Yes;" & _
					"MaxBufferSize=4096;" & _
					"MaxScanRows=5;" & _
					"PageTimeout=5;" & _
					"ReadOnly=0;" & _
					"SafeTransactions=0;" & _	
					"Treads=3;" & _
					"UserCommitSync=Yes"
		;-----------------------------------------------------------------------
		sleep(300)
		;    Access
			If $undef=True then
				If RedJet($defDir & "\" & $fileName)=-1 then return 0
			EndIf
		
		Case $SourceType=2	;   EXCEL

	;[   Excel]
	;------------------------------------------------------------------------------

	$DriverType=		"Microsoft Excel Driver (*.xls)"
	$ConfigurationData=	"DSN=" & $DSN & ";" & _
		  		"Description=   [Excel];" & _
				"DBQ=" & $defDir & "\" & $fileName & ";" & _
				"DefaultDir=" & $defDir & ";" & _
			  	"FileType=Excel;" & _
			   	"MaxScanRows=5"
	;  Excel      
	;    			
	EndSelect

	;-------------------------------------------------------------------------------
	MsgBox(262192, _
		"!", _
		"     ," 	& @CRLF & _
		"          " 		& @CRLF & _
		"        ." )

	;[  ]
	;-------------------------------------------------------------------------------
	sleep(100)
	$result = DllCall($dll_1, _
			"short", 	"SQLConfigDataSource", _
			"hwnd", 	0, _
			"long", 	$ODBC_ADD_SYS_DSN, _
			"str", 		$DriverType, _
			"str", 		$ConfigurationData)
	;-------------------------------------------------------------------------------
	sleep(100)
	If $result[0]<>1 then
		ODBCErroHandler(8)
		DllClose($dll_1)
		return -1
	EndIf
	;-------------------------------------------------------------------------------
	DllClose($dll_1)
	sleep(100)

	;[   ]
	;-------------------------------------------------------------------------------
	RegWrite ("HKLM\Software\Depo","DataSourceName", "REG_SZ",$DSN)
	RegWrite ("HKLM\Software\Depo","DataSourceDestination","REG_SZ",$defDir & "\" & $fileName)
	

	ToolTip ("   ." & @CRLF & _
		   "  ...",-1,-1, _
	  "=====   =====")

	sleep(1000)

 	FreeResources()					;   
	sleep(300)
	;-------------------------------------------------------------------------------
	If AllocateConnection()=-1 then		 	;  
		LoadDepoList()
		return 0	
	EndIf
	sleep(300)

	;[   ]
	;-------------------------------------------------------------------------------
	$rCr=RecteateDataTables($undef)
	If $rCr=0 then 
		ToolTip("    ." & @CRLF & _
			   "  ." & @CRLF & _
			     "    ...",-1,-1, _
		       "=====   =====")
		sleep(300)
		If AllocateConnection()=-1 then		 ;  
			LoadDepoList()
			return 0	
		EndIf
	ElseIf $rCr=-1 then 
		FreeResources()
	return 0
	EndIf
	;-------------------------------------------------------------------------------
	GUISwitch($GUI2)
	GUISetState(@SW_SHOW)
	GUISetState(@SW_HIDE)
	;-------------------------------------------------------------------------------
	LoadDepoList()
	Msgbox(64,	" .", _
			"    ." & @CRLF & _
			"     ODBC.")
return 0
EndFunc


;[    ]
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Func AllocateConnection()	

	;[    ]
	;-------------------------------------------------------------------------------
	$ConnStr	=RegRead("HKLM\Software\Depo","DataSourceName")
	$LogIn		=RegRead("HKLM\Software\Depo","Login")
	$Password	=RegRead("HKLM\Software\Depo","Password")

	$dll=DllOpen("odbc32.DLL")	;   ODBC

	;  
	If $dll=-1 then 
		ODBCErroHandler(9)
		Exit
	EndIf
	
	;[  ]
	;-------------------------------------------------------------------------------
	Local $AllocBuffer= DllStructCreate("udword")
	$result=DllCall($dll, _
			"short","SQLAllocEnv", _
			"long",DllStructGetPtr($AllocBuffer))

	;  
	If $result[0]<>$SQL_SUCCESS then
 		ODBCErroHandler(1)
		return -1
	EndIf
	
	$EnvironHandle=DllStructGetData($AllocBuffer,1)
	
	;[  ]
	;-------------------------------------------------------------------------------
	$AllocBuffer=0

	Local $AllocBuffer= DllStructCreate("udword")
	$result=DllCall($dll,"short","SQLAllocConnect", _
		         "long",$EnvironHandle, _
			 "long",DllStructGetPtr($AllocBuffer))

	;  
	If $result[0]<>$SQL_SUCCESS then 
		ODBCErroHandler(2)
		return -1
	EndIf

	;[     ]
	;-------------------------------------------------------------------------------
	$ConnHandle=DllStructGetData($AllocBuffer,1)
	$AllocBuffer=0

	$result=DllCall($dll,"short","SQLConnectW", _
			 "long",$ConnHandle, _
		         "wstr",$ConnStr, _
		         "long",StringLen($ConnStr), _
		         "wstr",$Login, _
		         "long",StringLen($Login), _
		         "wstr",$Password, _
		         "long",StringLen($Password))

	;  
	If $result[0]<>$SQL_SUCCESS then
 		ODBCErroHandler(3)
		$m="   " & @CRLF & _
		   "   " & $ConnStr
		ToolTip ($m ,-1,-1,"==== ====")
		return -1
	EndIf

	;[  ]
	;-------------------------------------------------------------------------------
	Local $AllocBuffer= DllStructCreate("udword")
	$result=DllCall($dll,"short","SQLAllocStmt", _
		"long",$ConnHandle, _
		"long",DllStructGetPtr($AllocBuffer))
	$StmtHandle=DllStructGetData($AllocBuffer,1)

	;  
	If $result[0]<>$SQL_SUCCESS then
 		ODBCErroHandler(4)
		return -1
	EndIf
	$AllocBuffer=0
	
	;[     ]
	;-------------------------------------------------------------------------------
	$DBQ=RegRead ("HKLM\Software\Depo","DataSourceDestination")
	If  $StmtHandle <>0 then $m=@CRLF & _
		"[ ]" 		& @CRLF & _
		 $ConnStr	 			& @CRLF & _
		"[  ]" 	& @CRLF & _
		 $DBQ 	 			& @CRLF & _
		"    " 		& @CRLF & _
		"      ." 	& @CRLF & _
		"Poltergeyst 2006-2009"

	ToolTip ($m ,-1,-1,"=====    =====")
	sleep(1000)
	ToolTip("")
;------------------------------------------------------------------------------------
	return 0
EndFunc


;[ ]
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Func FreeResources()
	$sp=SplashTextOn 	("LOG","",400,50,-1,-1,1,$FONT,$FS,$FW)

	;[  ]
	;----------------------------------------------------------------------------

	$result=DllCall($dll,"short","SQLFreeStmt", _
			"long",$StmtHandle, _				
			"long",$SQL_DROP)	
	ControlSetText("LOG","","Static1",@CRLF & " .  ...")
	sleep(100)

	;[    ]
	;----------------------------------------------------------------------------
	
	$result=DllCall($dll,"short","SQLDisconnect", _
        	    	   "long",$ConnHandle)

	sleep(100)
	
	;[  ]
	;-----------------------------------------------------------------------------

	$result=DllCall($dll,"short","SQLFreeConnect", _
			"long",$ConnHandle)				

	sleep(100)

	;[  ]
	;-----------------------------------------------------------------------------

	$result=DllCall($dll,"short","SQLFreeEnv", _
			"long",$EnvironHandle)

	sleep(1000)
	;----------------------------------------------------------------------------
	
	SplashOff()
	DllClose($dll)
	return 0
EndFunc


;[    ]
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Func StaticSQLStatement($SQL_Command)

	$Len=StringLen($SQL_Command)
	$result=DllCall($dll,"short","SQLExecDirectW", _
			         "long"	,$StmtHandle, _				
			         "wstr"	,$SQL_Command, _			
		        	 "long"	,$Len)

	;  
	If $result[0]<>$SQL_SUCCESS then 
		ODBCErroHandler(5)
		return -1
	EndIf
	sleep(100)
	return 0
EndFunc


;[   ]
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Func QuerySQLStatement($ColCount)

	Local $Buffer1= DllStructCreate("int")
	Local $Buffer2= DllStructCreate("char[260]")

	;[   ]
	;-----------------------------------------------------------------------------

	$result=DllCall($dll,"short","SQLFetchScroll", _
				"long",$StmtHandle, _		;Statement
				"short",$SQL_FETCH_NEXT, _	;Orientation
				"int",0)			;Offset

	If $result[0]=$SQL_NO_DATA_FOUND then return $SQL_NO_DATA_FOUND
	
	;[   ]	
	;-----------------------------------------------------------------------------
	$Cdata=""
	For $i=1 to $ColCount
	$result=DllCall($dll, _
			"short" ,"SQLGetData", _
			"long" ,$StmtHandle, _				; 
			"long" ,$i, _					; 
			"long" ,$SQL_C_CHAR, _				;  
			"str"  ,DllStructGetPtr($Buffer2), _		; 
			"long" ,260, _					;  
			"long" ,DllStructGetPtr($Buffer1))		;   

	;-----------------------------------------------------------------------------
	$RealBuffer=DllStructGetData($Buffer1,1)

	;[   ]
	;-----------------------------------------------------------------------------
	If $RealBuffer=-1 then return $SQL_NO_DATA_FOUND

	;  
	If $result[0]<>$SQL_SUCCESS then 
		ODBCErroHandler(6)
		return -1
	EndIf

	;[  ]
	;-----------------------------------------------------------------------------
	DllStructSetData($Buffer1,1,0)
	DllStructSetData($Buffer2,1,"")
	$Cdata=$Cdata & $result[4] & "|"
Next
;-------------------------------------------------------------------------------------
	return $Cdata
EndFunc


;[  ]
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Func ReloadStatement()

	;[  ]
	;-----------------------------------------------------------------------------

	$result=DllCall($dll,"short","SQLFreeStmt", _
			"long",$StmtHandle, _				
			"long",$SQL_DROP)	

	;[  ]
	;-----------------------------------------------------------------------------
	Local $AllocBuffer= DllStructCreate("udword")
	$result=DllCall($dll,"short","SQLAllocStmt", _
			"long",$ConnHandle, _
			"long",DllStructGetPtr($AllocBuffer))

	$StmtHandle=DllStructGetData($AllocBuffer,1)
	$AllocBuffer=0

	If $result[0]<>$SQL_SUCCESS then
		ODBCErroHandler(5)
		return -1
	EndIf
;--------------------------------------------------------------------------------------
return 0
EndFunc



;[ ]
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Func ExternalRuns($run)
	Select
	;----------------------------------------------------------------------------
	Case $run=1
		;/    /
		Select 
		Case $ConnStr="DepoAccess"
			$Ext="Access files(*.mdb)|All files(*.*)"
			$TimeStamp=StringFormat("_DT%s.%s.%s_%s.%s.%s.mdb",@MDAY,@MON,@YEAR,@HOUR,@MIN,@SEC)
		Case $ConnStr="DepoExcel"
			$Ext="Excel files(*.xls)|All files(*.*)"
			$TimeStamp=StringFormat("_DT%s.%s.%s_%s.%s.%s.xls",@MDAY,@MON,@YEAR,@HOUR,@MIN,@SEC)
		EndSelect
		
		$pathTo=FileSaveDialog ("   ",$WorkDir & "\reserve",$Ext,16,$ConnStr & $Timestamp)
		If @error then return 0
		$DBQ=	RegRead("HKLM\Software\Depo","DataSourceDestination")
			FileCopy ($DBQ,$pathTo,8)
		MsgBox(64,"  ","       .")
	;------------------------------------------------------------------------------
	Case $run=2
	;/   /
		RunWait(@SystemDir & "\odbcad32.exe",@SystemDir)
	;------------------------------------------------------------------------------
	Case $run=3
	;/  Microsoft Data Link/
		$MSDASC=""	
		$MSDASC=RegRead("HKEY_CLASSES_ROOT\MSDASC\shell\open\command","")
		$MSDASC=StringReplace($MSDASC,"%1","")
			  RunWait($MSDASC & "Msdasc.udl")		
EndSelect	
return 0
EndFunc



;[   ]
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Func RecteateDataTables($undef)
	If ReloadStatement()=-1 then return -1	; 
	;----------------------------------------------------------------------------
	If $undef=False then
		$iMsgBoxAnswer = MsgBox(52, _
			"   ", _
			"   ?")
		Select
		   Case $iMsgBoxAnswer = 6 ;Yes
		   Case $iMsgBoxAnswer = 7 ;No
			return -2
		EndSelect
	EndIf
	
	;[   ]
	;----------------------------------------------------------------------------
	Dim $TProp[3][5]

	;/ /
	$TProp[0][0]="DEPO"
	$TProp[0][1]="GROUPS"
	$TProp[0][2]="PROD"
	$TProp[0][3]="DPR"
	$TProp[0][4]="OPER"

	;/ /
	$TProp[1][0]="(n0 varchar,n1 varchar)"
	$TProp[1][1]="(n0 varchar,n1 varchar,n2 varchar)"
	$TProp[1][2]="(n0 varchar,n1 varchar,n2 varchar,x1 varchar,x2 varchar,x3 varchar,x4 varchar,d varchar)"
	$TProp[1][3]="(ot varchar,oid varchar,n2 varchar,x1 varchar,x2 varchar,x3 varchar,x4 varchar,d1 varchar,d2 varchar)"
	$TProp[1][4]="(ot varchar,oid varchar,od varchar,cmt varchar)"

	;/ /
	$TProp[2][0]="[     ]"
	$TProp[2][1]="[      ]"
	$TProp[2][2]="[     ]"
	$TProp[2][3]="[      ]"
	$TProp[2][4]="[    ]"

	;[   ]
	;----------------------------------------------------------------------------
	If $undef=True then
	ToolTip ("      ...",-1,-1, _
						"=====   =====")
	sleep(3000)
	;----------------------------------------------------------------------------
	For $j=0 to 4
		$SQL_Command="CREATE TABLE " & $TProp[0][$j] & $TProp[1][$j]
		StaticSQLStatement($SQL_Command)
		If ReloadStatement()=-1 then return -1				;  
		sleep(300)
			ToolTip ("  " & $TProp[0][$j] & @CRLF & _
		$TProp[2][$j] ,-1,-1, 	"=====   =====")

	Next
	;-----------------------------------------------------------------------------
	FreeResources()								;     
	ControlSetText	("LOG","","Static1",@CRLF & _
	"      .  ...")
	sleep(100)
	return 0
EndIf


	;[     ]
	;-----------------------------------------------------------------------------
	For $j=0 to 4
		;----------------------------------------------------------------------
		$iMsgBoxAnswer = MsgBox(51,"   ","  {" & $TProp[0][$j] & "}?"  & @CRLF & _
		$TProp[2][$j])
		Select
   			Case $iMsgBoxAnswer = 6 ;Yes
				$SQL_Command="DROP TABLE " & $TProp[0][$j]
				StaticSQLStatement($SQL_Command)
				sleep(300)
				If ReloadStatement()=-1 then return -1		;  

		   	Case $iMsgBoxAnswer = 7 ;No
		
			Case $iMsgBoxAnswer = 2 ;Cancel
				FreeResources()					;     
			return 0
		EndSelect
		;----------------------------------------------------------------------
	

	$iMsgBoxAnswer = MsgBox(51,"   ","   {" & $TProp[0][$j] & "}?" & @CRLF & _
	$TProp[2][$j])
	;------------------------------------------------------------------------------
	Select
   	Case $iMsgBoxAnswer = 6 ;Yes
		$SQL_Command="CREATE TABLE " & $TProp[0][$j] & $TProp[1][$j]
		StaticSQLStatement($SQL_Command)
		sleep(300)
		If ReloadStatement()=-1 then return -1				;  
   	Case $iMsgBoxAnswer = 7 ;No

	Case $iMsgBoxAnswer = 2 ;Cancel
		FreeResources()							;     
		return 0
	EndSelect
	;-----------------------------------------------------------------------------
Next
	FreeResources()						      		;     
	return 0
EndFunc


;[   Access]
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Func RedJet($Path)
	;/    Access/
	$DriverType		="Microsoft Access Driver (*.mdb)"
	$CreateAccessData	='CREATE_DB="'& $Path & '"'
	
	;[    Access    ]
	;-----------------------------------------------------------------------------
	$result = DllCall($dll_1, _
		"short", 	"SQLConfigDataSource", _
		"hwnd", 	0, _
		"long", 	$ODBC_ADD_SYS_DSN, _
		"str",		$DriverType, _
		"str",		$CreateAccessData)
		sleep(300)
		;---------------------------------------------------------------------
				If $result[0]<>1 then
					ODBCErroHandler(7)
					DllClose($dll_1)
					return -1
				EndIf
		;---------------------------------------------------------------------
		sleep(100)

		;[ ]
		;---------------------------------------------------------------------
		$Exist=FileExists ( $Path )
		If  $Exist=1 then
			MsgBox (64," JET.  Access", "    Access." & @CR & _
				$Path)
				return 0
		ElseIf $Exist=0 then
			MsgBox (262192," JET.  Access", "     Access." & @CR & _
				"    .")
				DllClose($dll_1)
				return -1
		EndIf

EndFunc

;[  API]
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Func ODBCErroHandler($Source)
	SplashOff()
	Select 
		;---------------------------------------------------------------------
		Case $Source=1
			Msgbox(16,"  ENV Descriptor", _		
			"   ." 		& @CRLF & _
			"  .")
			return 0
		;---------------------------------------------------------------------
		Case $Source=2
			Msgbox(16,"  DBC Descriptor", _		
			"   ." 		& @CRLF & _
			"  .")
			return 0
		;----------------------------------------------------------------------
		Case $Source=3
			Msgbox(16,"  ", _		
			"     ." 	& @CRLF & _
			"  .")
			return 0
		;----------------------------------------------------------------------
		Case $Source=4
			Msgbox(16,"  STMT Descriptor", _
			"   ."		& @CRLF & _
			"  . SQL  ."
			"  .")
			return 0
		;-----------------------------------------------------------------------
		Case $Source=5
			Msgbox(16,"  SQL ", _		
			"   .")
			return 0
		;-----------------------------------------------------------------------
		Case $Source=6
			Msgbox(16,"  ", _		
			"    .")
			return 0
		;-----------------------------------------------------------------------
		Case $Source=7
			MsgBox(262192, " JET.  Access", _
					"        source.mdb." 	& @CRLF & _
					"        ." & @CRLF & _
					"    .")
			return 0
		;-----------------------------------------------------------------------
		Case $Source=8
			MsgBox(262192, "ODBC installer.  ", _
					"    ." 	& @CRLF & _
					"    .")
			return 0
		;-----------------------------------------------------------------------
		Case $Source=9
			Msgbox(16,"  DLL", _
					"   ODBC32.DLL." 		& @CRLF & _
					"    ." 		& @CRLF & _
					"  ." )	
			return 0
		;-----------------------------------------------------------------------
		Case $Source=10
			Msgbox(262192,"  DLL", _
					"   ODBCCP32.DLL."  		& @CRLF & _		
					"    ." 	& @CRLF & _
					"  "  		& @CRLF & _
					"    .")
			return 0
		;----------------------------------------------------------------------
EndSelect
	return 0
EndFunc

;Poltergeyst 2006-2009