;-------------------------------------------------------------------------------------------------
;--------------------------    v1.2 beta -------------------------------------------
;-------------------------------------------------------------------------------------------------
	#NoTrayIcon
	#include <GUIConstants.au3>			;   
	#include <help_lib_api.au3>			; 
	#include <depo_lib_api.au3>			;   
	#include <groups_lib_api.au3>		;   
	#include <prod_lib_api.au3>			;   
	#include <operations_lib_api.au3>	; 
	#include <db_lib_api.au3>			;   
	#include <acc_lib_api.au3>			;  
	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	;/   /
	;     
	$processList=ProcessList(StringRegExpReplace(@AutoItExe,'.+\\',''))

	;       dv1.2beta.exe
	if $processList[0][0]>1 then 
		MsgBox(262192, "   v1.2 beta","  [  ]  .")
		Exit
	EndIf	
	
	
	;[    ]
	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	Global $EnvironHandle 	; 
	Global $ConnHandle		; 
	Global $StmtHandle		; 
	Global $dll,$dll_1		; :   ODBC32.dll, ODBCCP32.dll
	Global $ConnStr			; 
	Global $DepoId			;  
	Global $DepoName		;  
	Global $GroupId			;  
	Global $GroupName		;  
	Global $opType			;  
	Global $Opname			;  
	Global $minus			;  [      ]
	Global $G1_LV1			;  
	Global $PrevJournalItem	;   
	Global $OperationId		;  
	Global $G1_LV1Selected	;  
	Global $loadGr,$loadDp	;  
	Global $m				;   
	Global $ControlParam 	;     [menu  D&D]

	Global Const $WorkDir	=@ScriptDir								;  
	$ini					=$WorkDir & "\strings.ini"				;   
	$chelp					=FileOpen($WorkDir & "\chelp.txt",0)	;   
	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	;/  SQL/

	Global Const $SQL_SUCCESS=0
	Global Const $SQL_NO_DATA_FOUND=100
	Global Const $SQL_C_CHAR=1
	Global Const $SQL_DROP=1

	Global Const $SQL_FD_FETCH_ABSOLUTE	= 16
	Global Const $SQL_FD_FETCH_FIRST	= 2    
	Global Const $SQL_FD_FETCH_LAST		= 4   
	Global Const $SQL_FD_FETCH_NEXT		= 1   
	Global Const $SQL_FD_FETCH_PRIOR	= 8  
	Global Const $SQL_FD_FETCH_RELATIVE	= 32  
	Global Const $SQL_FETCH_ABSOLUTE	= 5    
	Global Const $SQL_FETCH_DIRECTION	= 8   
	Global Const $SQL_FETCH_FIRST		= 2   
	Global Const $SQL_FETCH_LAST		= 3   
	Global Const $SQL_FETCH_NEXT		= 1   
	Global Const $SQL_FETCH_PRIOR		= 4   
	Global Const $SQL_FETCH_RELATIVE	= 6

	Global Const $ODBC_ADD_DSN 			= 1
	Global Const $ODBC_CONFIG_DSN 		= 2
	Global Const $ODBC_REMOVE_DSN 		= 3
	Global Const $ODBC_ADD_SYS_DSN 		= 4
	Global Const $ODBC_CONFIG_SYS_DSN 	= 5
	Global Const $ODBC_REMOVE_SYS_DSN 	= 6
	Global Const $ODBC_REMOVE_DEFAULT_DSN 	= 7

	AllocateConnection()			;    
	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	;/  /
	Opt("GUIOnEventMode",1)						;  
	Opt("RunErrorsFatal",0)						;       
	Opt("GUICloseOnESC",1)						;   ESC
	Opt	("GUIResizeMode",$GUI_DOCKHCENTER)		;      

	;        
	Opt("OnExitFunc","FreeResources")
	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	;/   /
	
	$FONT				=RegRead("HKLM\Software\Depo\API","Font")
	$FW					=RegRead("HKLM\Software\Depo\API","FTweight")
	$FS					=RegRead("HKLM\Software\Depo\API","FTstyle")
	$GUI_COLOR			=RegRead("HKLM\Software\Depo\API","GUIcolor")
	$LV_COLOR			=RegRead("HKLM\Software\Depo\API","LVcolor")
	$MC					=RegRead("HKLM\Software\Depo\API","MNcolor")
	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	;/     ListView/

	Global Const $LVIF_TEXT             	= 0x0001
	Global Const $LVM_FIRST					= 0x1000
	Global Const $LVM_GETITEM           	= $LVM_FIRST + 5
	Global Const $LVM_GETITEMCOUNT      	= $LVM_FIRST + 4
	Global Const $LVM_DELETEITEM        	= $LVM_FIRST + 8
	Global Const $LVM_CLEARLV           	= $LVM_FIRST + 9
	Global Const $LVM_SETCOLUMNWIDTH    	= $LVM_FIRST + 30
	Global Const $LVFI_PARAM            	= 0x0001
	Global Const $LVM_SETITEMTEXT       	= $LVM_FIRST + 46
	Global Const $LVIF_PARAM            	= 0x0004 
	Global Const $LVM_FINDITEM          	= $LVM_FIRST + 13
	Global Const $LVM_SETSELECTEDCOLUMN 	= $LVM_FIRST + 140

	;List
	Global Const $LB_GETTEXT		= 0x0189
	Global Const $LB_GETCOUNT 		= 0x18B
	Global Const $LB_SETSEL 		= 0x0186
	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	;/   /

	Global Const $WM_INITMENU		=0x0116
	Global Const $WM_INITMENUPOPUP	=0x0117
	 ;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	;/   ListItem ID/

	Global $stBuffer     = DllStructCreate("char[260]")
	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	;/     ListView/

	Global $stLvi        = DllStructCreate("uint;int;int;uint;uint;ptr;int;int;int;int")
	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	;/     /
	
   	DllStructSetData($stLvi, 1, $LVIF_TEXT)
	DllStructSetData($stLvi, 2, 0) 			;
	DllStructSetData($stLvi, 3, 0) 			;
	DllStructSetData($stLvi, 6, DllStructGetPtr($stBuffer))
   	DllStructSetData($stLvi, 7, 260) 	
	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	;/    /

	GUIRegisterMsg ($WM_INITMENUPOPUP, "MenuStub" )
	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	;/   /

;------------------------------------------------------------------
;------------------   ----------------------------------
;------------------------------------------------------------------
$TITLE	=IniRead ($ini,"GUI", "TITLE","")
$CHBOX0	=IniRead ($ini,"GUI", "CHBOX0","")
;------------------------------------------------------------------
$LISTHEAD	=IniRead ($ini,"GUI", "LISTHEAD","" )
$LAB		=IniRead ($ini,"GUI", "LAB","" )

$MENU1=IniRead ($ini,"GUI", "MENU1","")

$MENU1_MENUITEM1=IniRead ($ini,"GUI", "MENU1_MENUITEM1","")
$MENU1_MENUITEM2=IniRead ($ini,"GUI", "MENU1_MENUITEM2","")
$MENU1_MENUITEM3=IniRead ($ini,"GUI", "MENU1_MENUITEM3","")
$MENU1_MENUITEM31=IniRead($ini,"GUI", "MENU2_MENUITEM31","")

$MENU1_MENUITEM4=IniRead ($ini,"GUI", "MENU1_MENUITEM4","")
$MENU1_MENUITEM5=IniRead ($ini,"GUI", "MENU1_MENUITEM5","")
$MENU1_MENUITEM6=IniRead ($ini,"GUI", "MENU1_MENUITEM6","")

$MENU1_MENUITEM7=IniRead ($ini,"GUI", "MENU1_MENUITEM7","")
$MENU1_MENUITEM8=IniRead ($ini,"GUI", "MENU1_MENUITEM8","")
;------------------------------------------------------------------
$MENU2=IniRead ($ini,"GUI", "MENU2","")
$MENU2_MENUITEM1=IniRead ($ini,"GUI", "MENU2_MENUITEM1","")
$MENU2_MENUITEM2=IniRead ($ini,"GUI", "MENU2_MENUITEM2","")
$MENU2_MENUITEM3=IniRead ($ini,"GUI", "MENU2_MENUITEM3","")
;------------------------------------------------------------------
$MENU3=IniRead ($ini,"GUI", "MENU3","")
$MENU3_MENUITEM1=	IniRead ($ini,"GUI", "MENU3_MENUITEM1","")
$MENU3_MENUITEM2=	IniRead ($ini,"GUI", "MENU3_MENUITEM2","")
;------------------------------------------------------------------
;-------------     -------------------------------
;------------------------------------------------------------------
$GR_GUI=IniRead ($ini,"GR_GUI", "GR_GUI","")
$GROUP2=IniRead ($ini,"GR_GUI", "GROUP2","")
$GROUP3=IniRead ($ini,"GR_GUI", "GROUP3","")
$DLIST=IniRead  ($ini,"GR_GUI", "DLIST","")
$GLIST=IniRead  ($ini,"GR_GUI", "GLIST","")
$CHBOX1=IniRead ($ini,"GR_GUI", "CHBOX1","")

;------------------------------------------------------------------
$DMENU1=IniRead ($ini,"GR_GUI", "DMENU1","")
$DMENU2=IniRead ($ini,"GR_GUI", "DMENU2","")
$DMENU3=IniRead ($ini,"GR_GUI", "DMENU3","")

$DMENU1_MENUITEM1=IniRead ($ini,"GR_GUI", "DMENU1_MENUITEM1","")
$DMENU1_MENUITEM2=IniRead ($ini,"GR_GUI", "DMENU1_MENUITEM2","")
$DMENU1_MENUITEM3=IniRead ($ini,"GR_GUI", "DMENU1_MENUITEM3","")
$DMENU1_MENUITEM4=IniRead ($ini,"GR_GUI", "DMENU1_MENUITEM4","")
;------------------------------------------------------------------
$DMENU2_MENUITEM1=IniRead ($ini,"GR_GUI", "DMENU2_MENUITEM1","")
$DMENU2_MENUITEM2=IniRead ($ini,"GR_GUI", "DMENU2_MENUITEM2","")
$DMENU2_MENUITEM3=IniRead ($ini,"GR_GUI", "DMENU2_MENUITEM3","")
$DMENU2_MENUITEM4=IniRead ($ini,"GR_GUI", "DMENU2_MENUITEM4","")
$DMENU2_MENUITEM5=IniRead ($ini,"GR_GUI", "DMENU2_MENUITEM5","")
$DMENU2_MENUITEM6=IniRead ($ini,"GR_GUI", "DMENU2_MENUITEM6","")
;------------------------------------------------------------------
$DMENU3_MENUITEM1=IniRead ($ini,"GR_GUI", "DMENU3_MENUITEM1","")
$DMENU3_MENUITEM2=IniRead ($ini,"GR_GUI", "DMENU3_MENUITEM2","")

;------------------------------------------------------------------
;---------   ------------------------------------------
;------------------------------------------------------------------
$G1_L1		=IniRead ($ini,"GUI1", "G1_L1","")
$G1_RADIO1	=IniRead ($ini,"GUI1", "G1_RADIO1","")
$G1_RADIO2	=IniRead ($ini,"GUI1", "G1_RADIO2","")
$G1_RADIO3	=IniRead ($ini,"GUI1", "G1_RADIO3","")
$G1_RADIO4	=IniRead ($ini,"GUI1", "G1_RADIO4","")
$G1_L2		=IniRead ($ini,"GUI1", "G1_L2","")
$G1_RADIO5	=IniRead ($ini,"GUI1", "G1_RADIO5","")
$G1_RADIO6	=IniRead ($ini,"GUI1", "G1_RADIO6","")
$G1_L3		=IniRead ($ini,"GUI1", "G1_L3","")
$G1_L4		=IniRead ($ini,"GUI1", "G1_L4","")
$G1_L5		=IniRead ($ini,"GUI1", "G1_L5","")
$G1_BT		=IniRead ($ini,"GUI1", "G1_BT","")
$G1_B0		=IniRead ($ini,"GUI1", "G1_B0","")
$G1_B1		=IniRead ($ini,"GUI1", "G1_B1","")
$G1_B2		=IniRead ($ini,"GUI1", "G1_B2","")
$G1_LH		=IniRead ($ini,"GUI1", "G1_LH","")
$GUI1		=IniRead ($ini,"GUI1", "GUI1","")

;------------------------------------------------------------------
;------------     --------------------
;------------------------------------------------------------------
$GUI2=		IniRead ($ini,"GUI2", "GUI2","")
$G2_B1=		IniRead ($ini,"GUI2", "G2_B1","")
$G2_B2=		IniRead ($ini,"GUI2", "G2_B2","")
$G2_B3=		IniRead ($ini,"GUI2", "G2_B3","")
$G2_GROUP1=	IniRead ($ini,"GUI2", "G2_GROUP1","")
$G2_GROUP2=	IniRead ($ini,"GUI2", "G2_GROUP2","")
$G2_RADIO1=	IniRead ($ini,"GUI2", "G2_RADIO1","")
$G2_RADIO2=	IniRead ($ini,"GUI2", "G2_RADIO2","")


;[     ]
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

$GUI=GUICreate(". ",790,570, 0,0, _
			BitOr($WS_DLGFRAME,$WS_SYSMENU,$WS_MAXIMIZEBOX,$WS_MINIMIZEBOX,$WS_SIZEBOX), _
				$WS_EX_CLIENTEDGE)

	GUISetIcon ("icons\gui.bmp",0,$GUI)
	
	;/    /
	GUISetOnEvent 	($GUI_EVENT_DROPPED,"AddToOrder",$GUI)
	
	;/    /
	GUISetOnEvent	($GUI_EVENT_CLOSE,"ExitInterface",$GUI)
	
	;/     /
	WinSetState	($GUI, "", @SW_HIDE)
	
	;/  /
	GUISetFont	($FS,$FW,0,$FONT)
	GUISetBkColor 	($GUI_COLOR)

;[    ]
;-------------------------------------------------------------------------------------
$LIST1 = 	GUICtrlCreateListView	($LISTHEAD,3,3,784,300,-1, _
		$LVS_EX_GRIDLINES+$LVS_EX_FULLROWSELECT)
		
		GUICtrlSetBkColor       ($LIST1,$LV_COLOR)
		GUICtrlSetOnEvent		($LIST1,"EventsHandler")
		GUICtrlSendMsg		($LIST1,$LVM_SETCOLUMNWIDTH,6,0)

$LIST2 = 	GUICtrlCreateListView	($LISTHEAD,3,309,574,200,-1, _
		$LVS_EX_GRIDLINES+$LVS_EX_FULLROWSELECT)
		
		GUICtrlSetBkColor       ($LIST2,$LV_COLOR)
		GUICtrlSetOnEvent		($LIST2,"EventsHandler")
		GUICtrlSendMsg			($LIST2,$LVM_SETCOLUMNWIDTH,6,0)

;[    ]
;-------------------------------------------------------------------------------------

$MENU1 = GUICtrlCreateMenu ($MENU1)

$MENU1_MENUITEM1 = _
	GUICtrlCreateMenuitem	($MENU1_MENUITEM1 & @TAB & "[Ctrl+N]",$MENU1)
	GUICtrlSetOnEvent	($MENU1_MENUITEM1,"EventsHandler")

$MENU1_MENUITEM2 = _
	GUICtrlCreateMenuitem 	($MENU1_MENUITEM2 & @TAB & "[Ctrl+D]",$MENU1)
	GUICtrlSetOnEvent	($MENU1_MENUITEM2,"EventsHandler")
	
$MENU1_MENUITEM3 = _
	GUICtrlCreateMenuitem 	($MENU1_MENUITEM3 & @TAB & "[Ctrl+U]",$MENU1)
	GUICtrlSetOnEvent	($MENU1_MENUITEM3,"EventsHandler")

$MENU1_MENUITEM31 = _
	GUICtrlCreateMenuitem 	($MENU1_MENUITEM31 & @TAB & "[F9]"    ,$MENU1)
	GUICtrlSetOnEvent	($MENU1_MENUITEM31,"EventsHandler")

	GUICtrlCreateMenuitem ("",$MENU1)	
;-------------------------------------------------------------------------------------

$MENU1_MENUITEM4 = _
	GUICtrlCreateMenuitem 	($MENU1_MENUITEM4 & @TAB & "[F6]",$MENU1)
	GUICtrlSetOnEvent	($MENU1_MENUITEM4,"EventsHandler")

$MENU1_MENUITEM5 = _
	GUICtrlCreateMenuitem 	($MENU1_MENUITEM5 & @TAB & "[F5]"	,$MENU1)
	GUICtrlSetOnEvent	($MENU1_MENUITEM5,"EventsHandler")

$MENU1_MENUITEM6 = _
	GUICtrlCreateMenuitem 	($MENU1_MENUITEM6 & @TAB & "[Ctrl+DEL]" ,$MENU1)
	GUICtrlSetOnEvent	($MENU1_MENUITEM6,"EventsHandler")

	GUICtrlCreateMenuitem ("",$MENU1)

$MENU1_MENUITEM7 = _
	GUICtrlCreateMenuitem 	($MENU1_MENUITEM7,$MENU1)
	GUICtrlSetOnEvent	($MENU1_MENUITEM7,"EventsHandler")

$MENU1_MENUITEM8 = _
	GUICtrlCreateMenuitem 	($MENU1_MENUITEM8,$MENU1)
	GUICtrlSetOnEvent	($MENU1_MENUITEM8,"EventsHandler")

;-------------------------------------------------------------------------------------

$MENU2 = GUICtrlCreateMenu ($MENU2)

$MENU2_MENUITEM1 = _
	GUICtrlCreateMenuitem	($MENU2_MENUITEM1 & @TAB & "[F2]",$MENU2)
	GUICtrlSetOnEvent	($MENU2_MENUITEM1,"EventsHandler")

$MENU2_MENUITEM2 = _
	GUICtrlCreateMenuitem	($MENU2_MENUITEM2 & @TAB & "[F3]",$MENU2)
	GUICtrlSetOnEvent	($MENU2_MENUITEM2,"EventsHandler")

$MENU2_MENUITEM3 = _
	GUICtrlCreateMenuitem 	($MENU2_MENUITEM3 & @TAB & "[F4]",$MENU2)
	GUICtrlSetOnEvent	($MENU2_MENUITEM3,"EventsHandler")

;-------------------------------------------------------------------------------------
$MENU3 = GUICtrlCreateMenu ($MENU3)

$MENU3_MENUITEM1 = _
	GUICtrlCreateMenuitem	($MENU3_MENUITEM1 & @TAB & "[F1]",$MENU3)
	GUICtrlSetOnEvent	($MENU3_MENUITEM1,"EventsHandler")

$MENU3_MENUITEM2 = _
	GUICtrlCreateMenuitem	($MENU3_MENUITEM2,$MENU3)
	GUICtrlSetOnEvent	($MENU3_MENUITEM2,"EventsHandler")

;[  ]
;-------------------------------------------------------------------------------------

$ORDER=	GUICtrlCreateInput 	("",580,309,207,60,$ES_READONLY)
		GUICtrlSetBkColor	($ORDER,$GUI_COLOR)
		GUICtrlSetColor		($ORDER,$GUI_COLOR)
		GUICtrlSetState		($ORDER,$GUI_ACCEPTFILES)
		GUICtrlSetResizing 	($ORDER,$GUI_DOCKAUTO)

$LAB=	GUICtrlCreateLabel 	(@CRLF & $LAB,580,309,207,60,$WS_BORDER+$SS_CENTER)
		GUICtrlSetBkColor	($LAB,$LV_COLOR)
		GUICtrlSetResizing 	($LAB,$GUI_DOCKAUTO)

;[   ]
;-------------------------------------------------------------------------------------

$CHBOX0=	GUICtrlCreateCheckbox   ($CHBOX0,580,374,207,30, _
			BitOr($WS_BORDER,$BS_FLAT,$BS_MULTILINE,$BS_CENTER))

$IMGBT1 = 	GUICtrlCreateButton 	("1",580,410,60,40, _
						$BS_ICON+$BS_PUSHLIKE)
		GUICtrlSetImage	 	($IMGBT1, "icons\im1.bmp")
		GUICtrlSetOnEvent	($IMGBT1,"EventsHandler")

$IMGBT2 = 	GUICtrlCreateButton 	("2",650,410,60,40, _
						$BS_ICON+$BS_PUSHLIKE)
		GUICtrlSetImage 	($IMGBT2, "icons\im2.bmp")
		GUICtrlSetOnEvent	($IMGBT2,"EventsHandler")

$IMGBT3 = 	GUICtrlCreateButton 	("3",720,410,60,40, _
						$BS_ICON+$BS_PUSHLIKE)
		GUICtrlSetImage 	($IMGBT3, "icons\im3.bmp")
		GUICtrlSetOnEvent	($IMGBT3,"EventsHandler")

$IMGBT4 = 	GUICtrlCreateButton 	("4",580,460,60,40, _
						$BS_ICON+$BS_PUSHLIKE)
		GUICtrlSetImage 	($IMGBT4, "icons\im4.bmp")
		GUICtrlSetOnEvent	($IMGBT4,"EventsHandler")

$IMGBT5 = 	GUICtrlCreateButton 	("5",650,460,60,40, _
						$BS_ICON+$BS_PUSHLIKE)
		GUICtrlSetImage	 	($IMGBT5, "icons\im5.bmp")
		GUICtrlSetOnEvent	($IMGBT5,"EventsHandler")

$IMGBT6 = 	GUICtrlCreateButton 	("6",720,460,60,40, _
						$BS_ICON+$BS_PUSHLIKE)
		GUICtrlSetImage 	($IMGBT6, "icons\i3.bmp")
		GUICtrlSetOnEvent	($IMGBT6,"EventsHandler")

;[     ]
;-------------------------------------------------------------------------------------

$GR_GUI=	GUICreate($GR_GUI,300,530,0,0,$WS_DLGFRAME+$WS_SYSMENU, _
				$WS_EX_CLIENTEDGE)
		GUISetOnEvent	($GUI_EVENT_CLOSE,"HideGui",$GR_GUI)
		GUISetIcon	("icons\im1.bmp",0,$GR_GUI)
		GUISetFont   	($FS,$FW,0,$FONT)
		GUISetBkColor 	($GUI_COLOR)
;-------------------------------------------------------------------------------------
$GROUP2=	GUICtrlCreateGroup ($GROUP2,3,5,290,210)

$DLIST = 	GUICtrlCreateList(Chr(0),8,30,280,200, _
			$WS_BORDER+$WS_VSCROLL,$WS_EX_ACCEPTFILES)
		GUICtrlSetBkColor ($DLIST,$LV_COLOR)
		GUICtrlSetOnEvent ($DLIST,"EventsHandler")
;-------------------------------------------------------------------------------------
$GROUP3=	GUICtrlCreateGroup ($GROUP3,3,255,290,210)

$GLIST = 	GUICtrlCreateList ("",8,280,280,200, _
			$WS_BORDER+$WS_VSCROLL,$WS_EX_ACCEPTFILES)
 	 	GUICtrlSetBkColor ($GLIST,$LV_COLOR)
		GUICtrlSetOnEvent ($GLIST,"EventsHandler")

;[   ]
;-------------------------------------------------------------------------------------

$IMGBUTTON1 = 	GUICtrlCreateButton 	("1", 3,220,30,30, _
					$BS_ICON+$BS_PUSHLIKE)
		GUICtrlSetImage 	($IMGBUTTON1, "icons\i4.bmp")
		GUICtrlSetOnEvent	($IMGBUTTON1,"EventsHandler")

$IMGBUTTON2 = 	GUICtrlCreateButton 	("2", 36,220,30,30, _
					$BS_ICON+$BS_PUSHLIKE)
		GUICtrlSetImage 	($IMGBUTTON2, "icons\i3.bmp")
		GUICtrlSetOnEvent	($IMGBUTTON2,"EventsHandler")
;-------------------------------------------------------------------------------------
$CHBOX1=GUICtrlCreateCheckbox ($CHBOX1,69,220,220,30, _
		BitOr($WS_BORDER,$BS_FLAT,$BS_MULTILINE,$BS_CENTER))
		GUICtrlSetState	($CHBOX1,$GUI_CHECKED)			;

;[    ]
;-------------------------------------------------------------------------------------
$DMENU1=		GUICtrlCreateMenu	($DMENU1)

$DMENU1_MENUITEM1  = 	GUICtrlCreateMenuitem 	($DMENU1_MENUITEM1,$DMENU1)
			GUICtrlSetOnEvent	($DMENU1_MENUITEM1,"EventsHandler")

$DMENU1_MENUITEM2  = 	GUICtrlCreateMenuitem 	($DMENU1_MENUITEM2,$DMENU1)
			GUICtrlSetOnEvent	($DMENU1_MENUITEM2,"EventsHandler")

$DMENU1_MENUITEM3  = 	GUICtrlCreateMenuitem 	($DMENU1_MENUITEM3,$DMENU1)
			GUICtrlSetOnEvent	($DMENU1_MENUITEM3,"EventsHandler")

GUICtrlCreateMenuitem ("",$MENU2)	

$DMENU1_MENUITEM4  = 	GUICtrlCreateMenuitem 	($DMENU1_MENUITEM4,$DMENU1)
			GUICtrlSetOnEvent	($DMENU1_MENUITEM4,"EventsHandler")
;-------------------------------------------------------------------------------------
$DMENU2=		GUICtrlCreateMenu	($DMENU2)

$DMENU2_MENUITEM1    = 	GUICtrlCreateMenuitem 	($DMENU2_MENUITEM1,$DMENU2)
			GUICtrlSetOnEvent	($DMENU2_MENUITEM1,"EventsHandler")

$DMENU2_MENUITEM2   = 	GUICtrlCreateMenuitem 	($DMENU2_MENUITEM2,$DMENU2)
			GUICtrlSetOnEvent	($DMENU2_MENUITEM2,"EventsHandler")

$DMENU2_MENUITEM3    = 	GUICtrlCreateMenuitem 	($DMENU2_MENUITEM3,$DMENU2)
			GUICtrlSetOnEvent	($DMENU2_MENUITEM3,"EventsHandler")

$DMENU2_MENUITEM4    = 	GUICtrlCreateMenuitem 	($DMENU2_MENUITEM4,$DMENU2)
			GUICtrlSetOnEvent	($DMENU2_MENUITEM4,"EventsHandler")

			GUICtrlCreateMenuitem ("",$DMENU2)
	
$DMENU2_MENUITEM5    = 	GUICtrlCreateMenuitem 	($DMENU2_MENUITEM5,$DMENU2)
			GUICtrlSetOnEvent	($DMENU2_MENUITEM5,"EventsHandler")

$DMENU2_MENUITEM6    = 	GUICtrlCreateMenuitem 	($DMENU2_MENUITEM6,$DMENU2)
			GUICtrlSetOnEvent	($DMENU2_MENUITEM6,"EventsHandler")

;-------------------------------------------------------------------------------------
$DMENU3=		GUICtrlCreateMenu	($DMENU3)

$DMENU3_MENUITEM1    = 	GUICtrlCreateMenuitem 	($DMENU3_MENUITEM1,$DMENU3)
			GUICtrlSetOnEvent	($DMENU3_MENUITEM1,"EventsHandler")

$DMENU3_MENUITEM2   = 	GUICtrlCreateMenuitem 	($DMENU3_MENUITEM2,$DMENU3)
			GUICtrlSetOnEvent	($DMENU3_MENUITEM2,"EventsHandler")

;[   ]
;-------------------------------------------------------------------------------------
$GUI1=	GUICreate		($GUI1,790,380, 0,0,$WS_DLGFRAME+$WS_SYSMENU, _
					$WS_EX_CLIENTEDGE)
		GUISetOnEvent	($GUI_EVENT_CLOSE,"HideGui",$GUI1)
		GUISetIcon 		("icons\im2.bmp",0,$GUI1)
		GUISetBkColor 	($GUI_COLOR)
		GUISetFont		($FS,$FW,0,$FONT)
;-------------------------------------------------------------------------------------
$G1_L1=	GUICtrlCreateLabel($G1_L1,3,3,150,40,$WS_BORDER+$SS_CENTER)
		GUICtrlSetColor		($G1_L1,0x0000FF)
		GUICtrlSetBkColor 	($G1_L1,0xffffff)

$G1_RADIO1=	GUICtrlCreateRadio	($G1_RADIO1,10,50,140,36,	$BS_FLAT+$WS_BORDER)
		GUICtrlSetState		($G1_RADIO1,$GUI_CHECKED);
$G1_RADIO2=	GUICtrlCreateRadio	($G1_RADIO2,10,85,140,36,	$BS_FLAT+$WS_BORDER)
		
$G1_RADIO3=	GUICtrlCreateRadio	($G1_RADIO3,10,120,140,35,	$BS_FLAT+$WS_BORDER)
		
;-------------------------------------------------------------------------------------
$G1_L2=	GUICtrlCreateLabel($G1_L2,3,160,150,40,$WS_BORDER+$SS_CENTER)
		GUICtrlSetColor		($G1_L2,0x0000FF)
		GUICtrlSetBkColor	($G1_L2,0xffffff)
$G1_RADIO4=	GUICtrlCreateRadio	($G1_RADIO4,10,205,140,36,	$BS_FLAT+$WS_BORDER)
		
$G1_RADIO5=	GUICtrlCreateRadio	($G1_RADIO5,10,240,140,36,	$BS_FLAT+$WS_BORDER)
		
$G1_RADIO6=	GUICtrlCreateRadio	($G1_RADIO6,10,275,140,35,	$BS_FLAT+$WS_BORDER)
		

$G1_B0=	GUICtrlCreateButton ($G1_B0,10,320,140,30, _
		BitOr($BS_CENTER,$BS_MULTILINE,$BS_VCENTER,$BS_FLAT))
		GUICtrlSetOnEvent	  ($G1_B0,"EventsHandler")
;-------------------------------------------------------------------------------------
$G1_L3=	GUICtrlCreateLabel($G1_L3,165,3,620,20,$WS_BORDER+$SS_CENTER)
		GUICtrlSetColor	($G1_L3,0x0000FF)
		GUICtrlSetBkColor	($G1_L3,0xffffff)
;/   /
$G1_LV1 = 		GUICtrlCreateListView($G1_LH,165,23,620,287,-1, _
			$LVS_EX_GRIDLINES+$LVS_EX_FULLROWSELECT)
			GUICtrlSetBkColor  ($G1_LV1,$LV_COLOR)
			GUICtrlSendMsg	   ($G1_LV1,$LVM_SETCOLUMNWIDTH,3,0)
;-------------------------------------------------------------------------------------
$G1_L4=		GUICtrlCreateLabel($G1_L4,165,320,100,30,$BS_MULTILINE)
$G1_D1=		GuiCtrlCreateDate("",240,320,100,30, _
				$DTS_SHORTDATEFORMAT)

$G1_L5=		GUICtrlCreateLabel($G1_L5,345,320,100,30,$BS_MULTILINE)
$G1_D2=		GuiCtrlCreateDate("",420,320,100,30, _
				$DTS_SHORTDATEFORMAT)

$G1_B1=		GUICtrlCreateButton ($G1_B1,540,315,100,40, _
			BitOr($BS_CENTER,$BS_MULTILINE,$BS_VCENTER,$BS_FLAT))
			GUICtrlSetOnEvent($G1_B1,"EventsHandler")

$G1_B2=		GUICtrlCreateButton ($G1_B2,650,315,100,40, _
			BitOr($BS_CENTER,$BS_MULTILINE,$BS_VCENTER,$BS_FLAT))
			GUICtrlSetOnEvent($G1_B2,"EventsHandler")

;[     ]
;-------------------------------------------------------------------------------------
$GUI2=		GUICreate	($GUI2 & $ConnStr,350,390, 0,0,$WS_DLGFRAME+$WS_SYSMENU, _
				$WS_EX_CLIENTEDGE)
		GUISetOnEvent	($GUI_EVENT_CLOSE,"HideGui",$GUI2)
		GUISetIcon 	("icons\im3.bmp",0,$GUI2)
		GUISetBkColor 	($GUI_COLOR)
		GUISetFont	($FS,$FW,0,$FONT)
;-------------------------------------------------------------------------------------
$G2_GROUP1=	GUICtrlCreateGroup($G2_GROUP1,6,6,330,180)

$G2_RADIO1=	GUICtrlCreateRadio	($G2_RADIO1,15,40,180,20,$BS_FLAT)
		GUICtrlSetOnEvent		($G2_RADIO1,"EventsHandler")
		GuiCtrlSetCursor		($G2_RADIO1,0)

$G2_RADIO2=	GUICtrlCreateRadio	($G2_RADIO2,15,65,180,20,$BS_FLAT)
		GUICtrlSetOnEvent		($G2_RADIO2,"EventsHandler")
		GuiCtrlSetCursor		($G2_RADIO2,0)
;-------------------------------------------------------------------------------------
$G2_B1=		GUICtrlCreateButton ($G2_B1,15,100,100,65, _
				BitOr($BS_CENTER,$BS_MULTILINE,$BS_VCENTER,$BS_FLAT))

			GUICtrlSetColor	($G2_B1,0x0000FF)
			GUICtrlSetBkColor ($G2_B1,0xffffff)
			GUICtrlSetOnEvent	($G2_B1,"EventsHandler")
;-------------------------------------------------------------------------------------
$G2_B2=		GUICtrlCreateButton ($G2_B2,120,100,100,65, _
				BitOr($BS_CENTER,$BS_MULTILINE,$BS_VCENTER,$BS_FLAT))

			GUICtrlSetColor	($G2_B2,0x0000FF)
			GUICtrlSetBkColor($G2_B2,0xffffff)
			GUICtrlSetOnEvent($G2_B2,"EventsHandler")
;-------------------------------------------------------------------------------------
$G2_B3=		GUICtrlCreateButton ($G2_B3,225,100,100,65, _
			BitOr($BS_CENTER,$BS_MULTILINE,$BS_VCENTER,$BS_FLAT))

			GUICtrlSetColor	($G2_B3,0x0000FF)
			GUICtrlSetBkColor($G2_B3,0xffffff)
			GUICtrlSetOnEvent($G2_B3,"EventsHandler")
;-------------------------------------------------------------------------------------
$G2_B4 = 	GUICtrlCreateButton ("1", 210,40,50,50, _
					$BS_ICON+$BS_PUSHLIKE)
		GUICtrlSetImage 	($G2_B4, "icons\odbc.bmp")
		GUICtrlSetOnEvent	($G2_B4,"EventsHandler")
;-------------------------------------------------------------------------------------
$G2_B5 = 	GUICtrlCreateButton ("2", 270,40,50,50, _
					$BS_ICON+$BS_PUSHLIKE)
		GUICtrlSetImage 	($G2_B5, "icons\dasc.bmp")
		GUICtrlSetOnEvent	($G2_B5,"EventsHandler")

$G2_GROUP1=	GUICtrlCreateGroup 	($G2_GROUP2,6,190,330,170)
$G2_EDIT1=  GUICtrlCreateEdit 	("",10,210,322,145,$ES_MULTILINE+$ES_READONLY+$ES_LEFT+$ES_AUTOVSCROLL+$ES_AUTOHSCROLL)
;-------------------------------------------------------------------------------------
Select 
	Case $ConnStr="DepoAccess"
		GUICtrlSetState($G2_RADIO1,$GUI_CHECKED)
	Case $ConnStr="DepoExcel"
		GUICtrlSetState($G2_RADIO2,$GUI_CHECKED)
EndSelect
;-------------------------------------------------------------------------------------
;/ /
		GUISwitch($GUI)
		
		GUISetState()
		Sleep(100)
		WinSetState		($GUI, "", @SW_MAXIMIZE)

;[  ]
;-------------------------------------------------------------------------------------
 HotKeySet("^n",	"CtrlN_Hk")		;   
 HotKeySet("^d",	"CtrlD_Hk")		;   
 HotKeySet("^u",	"CtrlU_Hk")		;  
 HotKeySet("^{DEL}","CtrlDel_Hk")	;  
 
 HotKeySet("{F1}",	"F1_Hk")		; 
 HotKeySet("{F2}",	"F2_Hk")		;    
 HotKeySet("{F3}",	"F3_Hk")		;    
 HotKeySet("{F4}",	"F4_Hk")		;    
 HotKeySet("{F5}",	"F5_Hk")		;   
 HotKeySet("{F6}",	"F6_Hk")		;   
 HotKeySet("{F9}",	"F9_Hk")		; 

$ControlParam=0		;      
SetTips()			;  
LoadDepoList()		;  

;[   GUI]
;-------------------------------------------------------------------------------------
;  		
		While 1
			$WinMsg=GUIGetMsg()
			;---------------------------------------
			;  
			Select
			Case WinActive($GUI)=1 
				$Win=$GUI
			Case WinActive($GR_GUI)=1 
				$Win=$GR_GUI
			Case WinActive($GUI1)=1 
				$Win=$GUI1
			Case WinActive($GUI2)=1 
				$Win=$GUI2
			EndSelect
			;---------------------------------------
			;       
			GUISwitch($Win)
			$CINF=GUIGetCursorInfo()
			If $CINF[2]=1 then ToolTip("")			;     
			If $CINF[3]=1 then HelpContext($CINF[4])	;     
			;---------------------------------------
			;      
			$G1_LV1Selected=ControlListView ("","",$G1_LV1,"GetSelected",0)
			If $G1_LV1Selected<>"" then
				ViewOperation()
				ControlListView ("","",$G1_LV1,"DeSelect",$G1_LV1Selected)
			EndIf
		WEnd

;[ ]
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Func EventsHandler()
$FROM_ELEMENT= @GUI_CTRLID
	Select
	;----------------------------------------------------------
	Case  $FROM_ELEMENT=$MENU1_MENUITEM1
	    	AddNewPosition(1)
		return 0
	;----------------------------------------------------------
	Case  $FROM_ELEMENT=$MENU2_MENUITEM1 OR $FROM_ELEMENT=$IMGBT1
		GUISwitch($GR_GUI)
		GUISetState(@SW_HIDE)
		GUISetState(@SW_SHOW)
		return 0
	;----------------------------------------------------------
	Case  $FROM_ELEMENT=$MENU2_MENUITEM2 OR $FROM_ELEMENT=$IMGBT2
		GUISwitch($GUI1)
		GUISetState(@SW_HIDE)
		GUISetState(@SW_SHOW)
		return 0
	;----------------------------------------------------------
	Case  $FROM_ELEMENT=$MENU2_MENUITEM3 OR $FROM_ELEMENT=$IMGBT3
		GUISwitch($GUI2)
		GUISetState(@SW_HIDE)
		GUISetState(@SW_SHOW)
		return 0
	;----------------------------------------------------------
	Case  $FROM_ELEMENT=$MENU1_MENUITEM7 OR $FROM_ELEMENT=$IMGBT5
		CreatePrevAccount()
		return 0
	;----------------------------------------------------------
	Case  $FROM_ELEMENT=$MENU1_MENUITEM8
		CreateProdCard()
		return 0
	;----------------------------------------------------------
	Case  $FROM_ELEMENT=$IMGBT6
		LoadPriceList(False)
		return 0
	;----------------------------------------------------------
	Case  $FROM_ELEMENT=$DMENU1_MENUITEM1
		AddNewDepo()
		return 0
	;----------------------------------------------------------
	Case  $FROM_ELEMENT=$DMENU1_MENUITEM2
		DeleteDepo()
		return 0
	;----------------------------------------------------------
	Case  $FROM_ELEMENT=$DMENU1_MENUITEM3
		UpdateDepo()
		return 0
	;----------------------------------------------------------
	Case  $FROM_ELEMENT=$DMENU2_MENUITEM1
		AddNewGroup()
		return 0
	;----------------------------------------------------------
	Case  $FROM_ELEMENT=$DMENU2_MENUITEM2
		DeleteGroup()
		return 0
      ;----------------------------------------------------------
	Case  $FROM_ELEMENT=$DMENU2_MENUITEM3
		UpdateGroup()	
		return 0
	;----------------------------------------------------------
	Case  $FROM_ELEMENT=$DMENU2_MENUITEM4 OR _
	      $FROM_ELEMENT=$IMGBUTTON1
		AddNewPosition(0)
		return 0
	;----------------------------------------------------------
	Case  $FROM_ELEMENT=$DMENU2_MENUITEM6
		LoadPriceList(True)
		return 0
	;----------------------------------------------------------
	Case  $FROM_ELEMENT=$DMENU3_MENUITEM1
		CreatePrice()
		return 0
	;----------------------------------------------------------
	Case  $FROM_ELEMENT=$DMENU3_MENUITEM2
		CreateStateAccount()
		return 0
	;----------------------------------------------------------
	Case  $FROM_ELEMENT=$MENU1_MENUITEM2
		DeletePosition()
		return 0
	;----------------------------------------------------------
	Case  $FROM_ELEMENT=$MENU1_MENUITEM3
		UpdatePosition(0)
		return 0
	;----------------------------------------------------------
	Case  $FROM_ELEMENT=$MENU1_MENUITEM31
		UpdatePosition(1)
		return 0
	;----------------------------------------------------------
	Case  $FROM_ELEMENT=$MENU1_MENUITEM4
		AddToOrder(1)
		$ControlParam=0
		return 0
	;----------------------------------------------------------
	Case  $FROM_ELEMENT=$MENU1_MENUITEM5
		AddToOrder(2)
		$ControlParam=0
		return 0
	;----------------------------------------------------------
	Case  $FROM_ELEMENT=$MENU1_MENUITEM6 OR _
		$FROM_ELEMENT=$IMGBT4
		GUICtrlSendMsg ($LIST2,$LVM_CLEARLV,0,0)
		GUICtrlSetTip  ($LIST2," ")
		return 0
	;----------------------------------------------------------
	Case  $FROM_ELEMENT=$MENU3_MENUITEM1
		OpenAccount($WorkDir & "\help.htm")
		return 0
	;----------------------------------------------------------
	Case  $FROM_ELEMENT=$MENU3_MENUITEM2
		GetSysInfo()
		return 0
	;----------------------------------------------------------
	Case  $FROM_ELEMENT=$DMENU2_MENUITEM5 OR _
	      $FROM_ELEMENT=$IMGBUTTON2
		LoadPriceList(False)
		return 0
	;----------------------------------------------------------
	Case  $FROM_ELEMENT=$DLIST
	$SZDepo=StringSplit(GUICtrlRead($DLIST),"_")
	$DepoId=	$SZDepo[1]
	$DepoName=	$SZDepo[2]
	$GroupId=	0
	$GroupName=	0
		LoadGroupList()
		return 0
	;----------------------------------------------------------
	Case  $FROM_ELEMENT=$GLIST
	$SZGroup=StringSplit(GUICtrlRead($GLIST),"_")
	$GroupId=	$SZGroup[1]	
	$GroupName=	$SZGroup[2]
	If GUICtrlRead($CHBOX1)=1 then LoadPriceList(False)
		return 0
      ;----------------------------------------------------------
	Case  $FROM_ELEMENT=$LIST1
			$ColForFilter=GUICtrlGetState($LIST1)
			$FilterSet=RegRead("HKLM\Software\Depo","filter" & $ColForFilter+1)			
			$inp=InputBox(" ","  ." & @CRLF & _
								    "    .",$FilterSet)
			If @error=1 then return 0
			RegWrite("HKLM\Software\Depo","filter" & $ColForFilter+1,"REG_SZ",$inp)
			LoadPriceList(False)
			return 0
	;----------------------------------------------------------
	Case  $FROM_ELEMENT=$G1_B0
		GUICtrlSetState		($CHBOX0,$GUI_UNCHECKED)
		GUICtrlSetState		($CHBOX0,$GUI_DISABLE)
		OpType()
		DropOrder($OpType,$Opname,$minus)
		GUISwitch($GUI)
		GUISetState()
		return 0
	;----------------------------------------------------------
	Case  $FROM_ELEMENT=$G1_B1
		GUICtrlSetState		($CHBOX0,$GUI_UNCHECKED)
		GUICtrlSetState		($CHBOX0,$GUI_DISABLE)
		GUICtrlSendMsg         	($LIST2,$LVM_CLEARLV,0,0)
		OpType()
		$Begin=	ConvertDate(GUICtrlRead($G1_D1),0)
		$End=		ConvertDate(GUICtrlRead($G1_D2),0)
		ViewJournal($OpType,$Begin,$End)
		GUISwitch($GUI1)
		GUISetState()
		return 0
	;----------------------------------------------------------
	Case  $FROM_ELEMENT=$G1_B2
	 		CreateAccount()
		return 0
	;----------------------------------------------------------
	Case  $FROM_ELEMENT=$G2_B1
	;    
		$rCr=RecteateDataTables(False)
	If $rCr=0 then 	;   
		ToolTip("    ." & @CRLF & _
			   "  ." & @CRLF & _
			     "    ...",-1,-1, _
		       "=====   =====")
			sleep(300)
				If AllocateConnection()=-1 then return 0		;  
			sleep(100)
				LoadDepoList()
	Msgbox(64," ."," .")
			return 0
	ElseIf $rCr=-1 then ;   
			return 0
	ElseIf $rCr=-2 then ; 
			return 0
	EndIf
			return 0
	;----------------------------------------------------------
	Case  $FROM_ELEMENT=$G2_B2
			Select 
				Case GUICtrlRead($G2_RADIO1)=1
					InspectDataSource(1)
				Case GUICtrlRead($G2_RADIO2)=1
					InspectDataSource(2)
			EndSelect
		return 0
	;----------------------------------------------------------
	Case  $FROM_ELEMENT=$G2_B3
		ExternalRuns(1)
		return 0
	;----------------------------------------------------------
	Case  $FROM_ELEMENT=$G2_RADIO1 
			InspectDataSource(1)
		return 0
	;----------------------------------------------------------
	Case  $FROM_ELEMENT=$G2_RADIO2 
			InspectDataSource(2)
		return 0
	;----------------------------------------------------------
	Case $FROM_ELEMENT=$G2_B4
 		ExternalRuns(2)
		return 0
	;----------------------------------------------------------
	Case $FROM_ELEMENT=$G2_B5 	
		ExternalRuns(3)
		return 0
	EndSelect	
		return 0
EndFunc

;[  ]
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Func ExitInterface()
 HotKeySet("^n")
 HotKeySet("^d")
 HotKeySet("^u")
 HotKeySet("^{DEL}")
 HotKeySet("{F1}")
 HotKeySet("{F2}")
 HotKeySet("{F3}")
 HotKeySet("{F4}")
 HotKeySet("{F5}")
 HotKeySet("{F6}")
 HotKeySet("{F9}")
 Exit
EndFunc

;[  ]
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Func HideGui()
	GUISwitch(@GUI_WINHANDLE)
	GUISetState(@SW_SHOW)
	GUISetState(@SW_HIDE)
EndFunc

;[  ]
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	Func CtrlN_Hk()
	HotKeySet("^n")
	HotKeySet("^n", "CtrlN_Hk")
		AddNewPosition(1)
		return 0
	EndFunc
	;--------------------------------
	Func CtrlD_Hk()
	HotKeySet("^d")
	HotKeySet("^d", "CtrlD_Hk")
		DeletePosition()
		return 0
	EndFunc
	;--------------------------------
	Func CtrlU_Hk()
	HotKeySet("^u")
	HotKeySet("^u", "CtrlU_Hk")
		UpdatePosition(0)
		return 0
	EndFunc
	;--------------------------------
	Func F9_Hk()
	HotKeySet("{F9}")
	HotKeySet("{F9}", "F9_Hk")
		UpdatePosition(1)
		return 0
	EndFunc
	;--------------------------------
	Func F6_Hk()
		HotKeySet("{F6}")
		HotKeySet("{F6}", "F6_Hk")
		AddToOrder(1)
		$ControlParam=0
		return 0
	EndFunc
	;--------------------------------
	Func F5_Hk()
	HotKeySet("{F5}")
	HotKeySet("{F5}", "F5_Hk")
		AddToOrder(2)
		$ControlParam=0
		return 0
	EndFunc
	;--------------------------------
	Func CtrlDel_Hk()
	HotKeySet("^{DEL}")
	HotKeySet("^{DEL}", "CtrlDel_Hk")
		GUICtrlSendMsg ($LIST2,$LVM_CLEARLV,0,0)
		GUICtrlSetTip  ($LIST2," ")
		return 0
	EndFunc
	;--------------------------------
	Func F2_Hk()
	HotKeySet("{F2}")
	HotKeySet("{F2}", "F2_Hk")
			GUISetState(@SW_HIDE,$GUI1)
			GUISetState(@SW_HIDE,$GUI2)
		GUISwitch($GR_GUI)
		GUISetState(@SW_HIDE)
		GUISetState(@SW_SHOW)
	EndFunc
	;--------------------------------
	Func F3_Hk()
	HotKeySet("{F3}")
	HotKeySet("{F3}", "F3_Hk")
			GUISetState(@SW_HIDE,$GR_GUI)
			GUISetState(@SW_HIDE,$GUI2)
		GUISwitch($GUI1)
		GUISetState(@SW_HIDE)
		GUISetState(@SW_SHOW)
	EndFunc
	;--------------------------------
	Func F4_Hk()
	HotKeySet("{F4}")
	HotKeySet("{F4}", "F4_Hk")
			GUISetState(@SW_HIDE,$GUI1)
			GUISetState(@SW_HIDE,$GR_GUI)
		GUISwitch($GUI2)
		GUISetState(@SW_HIDE)
		GUISetState(@SW_SHOW)
	EndFunc
	;--------------------------------
	Func F1_Hk()
	HotKeySet("{F1}")
	HotKeySet("{F1}", "F1_Hk")
		OpenAccount($WorkDir & "\help.htm")
		return 0
	EndFunc
	;--------------------------------

;[  (AutoIt sample)]
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;Retreived from AutoIt samples.Created by AutoIt team.
Func MenuStub($hWndGUI, $MsgID, $WParam, $LParam)
 Const $MIM_APPLYTOSUBMENUS   = 0x80000000
 Const $MIM_BACKGROUND        = 0x00000002 ;   !!!

If @OSVersion = "WIN_95" Or @OSVersion = "WIN_NT4" Then Return 0
   $hBrush = DllCall("gdi32.dll", "hwnd", "CreateSolidBrush", "int", $MC)
	If @error<>0 then return 0
   $hBrush = $hBrush[0]
Local $stMenuInfo = DllStructCreate("dword;dword;dword;uint;dword;dword;ptr")
    DllStructSetData($stMenuInfo, 1, DllStructGetSize($stMenuInfo))
    DllStructSetData($stMenuInfo, 2, BitOr($MIM_APPLYTOSUBMENUS, $MIM_BACKGROUND))
    DllStructSetData($stMenuInfo, 5, $hBrush)

    DllCall("user32.dll", "int", "SetMenuInfo", "hwnd", $WParam, "ptr", DllStructGetPtr($stMenuInfo))
	If @error<>0 then return 0
    $stMenuInfo = 0
Return $GUI_RUNDEFMSG
EndFunc
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;Poltergeyst 2006-2009