;------------------------------------------------------------------------------------------
; help_lib_api.au3     ------------------------
;------------------------------------------------------------------------------------------
; SetTips		;      
; GetSysInfo		;   
; HelpContext		;     
; ShowControlTip	;      


;[    ]
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Func SetTips()
GUICtrlSetTip($LIST1,		"      " & @CRLF & _
				"      .")
GUICtrlSetTip($LIST2,		" ")
GUICtrlSetTip($CHBOX0,		"    ")
GUICtrlSetTip($IMGBT1,		"    ") 		
GUICtrlSetTip($IMGBT2,		"  ,  ") 		
GUICtrlSetTip($IMGBT3,		"    ") 		
GUICtrlSetTip($IMGBT4,		"  ")
GUICtrlSetTip($IMGBT5,		" ")
GUICtrlSetTip($IMGBT6,		"/  ")   
GUICtrlSetTip($DLIST,		" ") 		
GUICtrlSetTip($GLIST,		"  ") 		
GUICtrlSetTip($IMGBUTTON1,	"     ") 	
GUICtrlSetTip($IMGBUTTON2,	"/  ") 	
GUICtrlSetTip($CHBOX1,		"     ")		
GUICtrlSetTip($G1_B0,		" ")		
GUICtrlSetTip($G1_LV1,		" ") 		
GUICtrlSetTip($G1_D1,		"    ")		
GUICtrlSetTip($G1_D2,		"    ")		
GUICtrlSetTip($G1_B1,		" ")		
GUICtrlSetTip($G1_B2,		"   ")		
GUICtrlSetTip($G2_RADIO1,	"   ACCESS 4.0")	
GUICtrlSetTip($G2_RADIO2,	"   EXCEL 8.0")	
GUICtrlSetTip($G2_B1,		"    ")		
GUICtrlSetTip($G2_B2,		"     ")		
GUICtrlSetTip($G2_B3,		"   ")		
GUICtrlSetTip($G2_B4,		"  ODBC") 		
GUICtrlSetTip($G2_B5,		"  Microsoft Data Link") 
EndFunc

;[   ]
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Func GetSysInfo()

$str1= _
"===================================================="			& @CRLF & _
" 		" 						& @CRLF & _
" 			" 	& @TAB 	& @TAB & @OSVersion 		& @CRLF & _
"			" 	& @TAB	& @TAB & @OSBuild 		& @CRLF & _
" 		" 	& @TAB 	& @TAB & @ProcessorArch 	& @CRLF & _
" 	" 	& @TAB	& @TAB & @UserName 		& @CRLF & _
" 		" 	& @TAB	& @TAB & @ComputerName 		& @CRLF & _
" 	"  	& @TAB	& @TAB & @DesktopWidth & "x" & @DesktopHeight & @CRLF & _
" 	"  	& @TAB	& @TAB & @DesktopDepth  	& @CRLF 

$str2= _
"===================================================="			& @CRLF & _
"		" 						& @CRLF 

	$DRV=DriveGetDrive("FIXED")
	$i=0
	$dstr=""
For $i=1 to $DRV[0]
$sstr= _
"			" 	& StringUpper($DRV[$i]) 	       		& @CRLF & _
" 	" 	& @TAB & @TAB & DriveGetFileSystem ($DRV[$i]) 	& @CRLF & _
" 		" 	& @TAB & @TAB & DriveGetSerial     ($DRV[$i]) 	& @CRLF & _
" 		" 	& @TAB & @TAB & DriveGetType 	    ($DRV[$i]) 	& @CRLF & _
"(mB)		" 	& @TAB & @TAB & Round(DriveSpaceFree ($DRV[$i]),2) & @CRLF & _
"(mB)		" 	& @TAB & @TAB & Round(DriveSpaceTotal($DRV[$i]),2) & @CRLF & _
"===================================================="	       			& @CRLF 
$dstr=$dstr & $sstr
Next

$mem=MemGetStats() 
$str3= _
"===================================================="			& @CRLF & _
" 		" 			       	 	& @CRLF & _
" (%)		" & @TAB & @TAB & Round($mem[0],2) & @CRLF & _
"  (kB)	" & @TAB & @TAB & Round($mem[1],2) 	& @CRLF & _
"  (kB)	" & @TAB & @TAB & Round($mem[2],2) 	& @CRLF & _
"  (mB)	" & @TAB & @TAB & Round($mem[3]/1024,2) & @CRLF & _
"   (mB)	" & @TAB & @TAB & Round($mem[4]/1024,2) & @CRLF & _
"  (mB)	" & @TAB & @TAB & Round($mem[5]/1024,2) & @CRLF & _
"  (mB)	" & @TAB & @TAB & Round($mem[6]/1024,2) & @CRLF & _
"===================================================="			& @CRLF 

$str4= _
"===================================================="			& @CRLF & _
":			|" & @CRLF & _
"Poltergeyst" & @CRLF & _
": 				|" & @TAB & @TAB & "AutoIt 3.1.1.127 beta" & @CRLF & _
":				|" & @TAB & @TAB & "1.2 beta" 		& @CRLF & _
":				|" & @TAB & @TAB & "" 		& @CRLF & _
"===================================================="	& @CRLF 

Msgbox(64,":  ",$str1 & $str3)
Msgbox(64,":   ",$str2 & $dstr)
Msgbox(64,": ",$str4)
return 0
EndFunc

;[     ]
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Func HelpContext($FROM_ELEMENT)

	Select
	;--------------------------------------------------
	;/  /
	;--------------------------------------------------
	Case   $FROM_ELEMENT=$IMGBT1
		ShowControlTip(2)
		return 0
	;--------------------------------------------------
	Case   $FROM_ELEMENT=$IMGBT2
		ShowControlTip(3)
		return 0
	;--------------------------------------------------
	Case   $FROM_ELEMENT=$IMGBT3
		ShowControlTip(4)
		return 0
	;--------------------------------------------------
	Case   $FROM_ELEMENT=$IMGBT4
		ShowControlTip(5)
		return 0
	;--------------------------------------------------
	Case   $FROM_ELEMENT=$IMGBT5
		ShowControlTip(6)
		return 0
	;--------------------------------------------------
	Case   $FROM_ELEMENT=$IMGBT6
		ShowControlTip(7)
		return 0
	;--------------------------------------------------
	Case  $FROM_ELEMENT=$LIST1
		ShowControlTip(8)
		return 0
	;--------------------------------------------------
	Case  $FROM_ELEMENT=$LIST2
		ShowControlTip(9)
		return 0
	;--------------------------------------------------
	Case  $FROM_ELEMENT=$LAB
		ShowControlTip(10)
		return 0
	;--------------------------------------------------
	Case  $FROM_ELEMENT=$CHBOX0
		ShowControlTip(11)
		return 0
	;--------------------------------------------------
	;/    /
	;--------------------------------------------------
	Case  $FROM_ELEMENT=$IMGBUTTON1
		ShowControlTip(13)
		return 0
	;--------------------------------------------------
	Case  $FROM_ELEMENT=$IMGBUTTON2
		ShowControlTip(14)
		return 0
	;--------------------------------------------------
	Case  $FROM_ELEMENT=$DLIST
		ShowControlTip(15)
		return 0
	;--------------------------------------------------
	Case  $FROM_ELEMENT=$GLIST
		ShowControlTip(16)
		return 0
	;--------------------------------------------------
	Case  $FROM_ELEMENT=$CHBOX1
		ShowControlTip(17)
		return 0
	;--------------------------------------------------
	;/    /
	;--------------------------------------------------
	Case  $FROM_ELEMENT=$G1_B0
		ShowControlTip(19)
		return 0
	;--------------------------------------------------
	Case  $FROM_ELEMENT=$G1_B1
		ShowControlTip(20)
		return 0
	;--------------------------------------------------
	Case  $FROM_ELEMENT=$G1_B2
		ShowControlTip(21)
		return 0
	;--------------------------------------------------
	Case  $FROM_ELEMENT=$G1_LV1
		ShowControlTip(23)
		return 0
	;--------------------------------------------------
	Case  $FROM_ELEMENT=$G1_D1
		ShowControlTip(24)
		return 0
	;--------------------------------------------------
	Case  $FROM_ELEMENT=$G1_D2
		ShowControlTip(25)
		return 0
	;--------------------------------------------------
	;/    /
	;--------------------------------------------------
	Case  $FROM_ELEMENT=$G2_B4
		ShowControlTip(27)
		return 0
	;--------------------------------------------------
	Case  $FROM_ELEMENT=$G2_B5
		ShowControlTip(28)
		return 0
	;--------------------------------------------------
	Case  $FROM_ELEMENT=$G2_RADIO1 
		ShowControlTip(29)
		return 0
	;--------------------------------------------------
	Case  $FROM_ELEMENT=$G2_RADIO2 
		ShowControlTip(30)
		return 0
	;--------------------------------------------------
	Case $FROM_ELEMENT=$G2_B1
		ShowControlTip(31)
		return 0
	;--------------------------------------------------
	Case $FROM_ELEMENT=$G2_B2 	
		ShowControlTip(32)
		return 0
	;--------------------------------------------------
	Case  $FROM_ELEMENT=$G2_B3
		ShowControlTip(33)
		return 0
	;--------------------------------------------------
	;/     /
	;--------------------------------------------------
	Case  StringRegExp ($G1_RADIO1 & $G1_RADIO2 & $G1_RADIO3 & $G1_RADIO4 & $G1_RADIO5 & $G1_RADIO6, _
	      $FROM_ELEMENT,0)
		ShowControlTip(22)
	EndSelect	
return 0
EndFunc

;[  ]
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Func ShowControlTip($line)
Local $tipWr
	ToolTip("")

	;/  /
	$Descr=FileReadLine($chelp,$line)
	$Descr=StringSplit($Descr," ")

	;/        /
	$j=1
	$ln=""
	While 1
		$ln=$ln & " " & $Descr[$j]
	If StringLen($ln)>50 or $j=$Descr[0] then
		$tipWr=$tipWr & $ln & @CRLF
		$ln=""
	EndIf
		$j=$j+1
	If   $j=$Descr[0]+1 then ExitLoop
	Wend

	;/  /	
	ToolTip ($tipWr,0,0,"======================= =======================")
return 0
EndFunc

;Poltergeyst 2006-2009

